various fixes
[automated-distro-installer] / myfai-chboot-local
index 4fc6f06bd56183162800004ce3750ab867ab0cfc..c631d5699d073e6e27d9ccae8d8454cce7c2b8e5 100755 (executable)
@@ -7,6 +7,7 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 kgped16=false
+bond=false
 fai_action=install
 fai_reboot_arg=,reboot
 while [[ $1 == -* ]]; do
@@ -26,7 +27,15 @@ while [[ $1 == -* ]]; do
       shift
       ;;
     -k)
-      kgped16=true;
+      kgped16=true
+      shift
+      ;;
+    -b)
+      bond=true
+      shift
+      ;;
+    --no-r)
+      fai_reboot_arg=
       shift
       ;;
   esac
@@ -39,18 +48,35 @@ err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $pre: $*" >&2; }
 
 host=$1
 
+
 rm -f /srv/tftp/fai/pxelinux.cfg/*
 if [[ ! $1 ]]; then
   echo "$0: clearing pxe config and exiting"
   exit 0
 fi
 
-# assuming ipv4, or else we might need to deal with multiple addresses
-# in an ipv4 + ipv6 network.
-my_ip=$(ip -4 route get 8.8.8.8 | sed -nr 's,^.*src\s+(\S+).*,\1,p')
-if [[ ! $my_ip || $my_ip =~ [[:space:]] ]]; then
-  echo "$0: error: failed to get \$my_ip, got: $my_ip"
-  exit 1
+# somewhat duplicated in brc hostip()
+case $host in
+  default) : ;;
+  [0-9:])
+    hostip=$host
+    ;;
+  *)
+    hostip=$(getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1)
+    ;;
+esac
+
+if [[ $hostip ]]; then
+
+  # assuming ipv4, or else we might need to deal with multiple addresses
+  # in an ipv4 + ipv6 network.
+  my_ip=$(ip -4 route get $hostip | sed -nr 's,^.*src\s+(\S+).*,\1,p')
+  if [[ ! $my_ip || $my_ip =~ [[:space:]] ]]; then
+    echo "$0: error: failed to get \$my_ip, got: $my_ip"
+    exit 1
+  fi
+else
+  my_ip=$(ip r show default | sed -r 's/.*via ([^ ]*).*/\1/' | head -n1)
 fi
 
 if [[ $host == default ]]; then
@@ -113,6 +139,8 @@ default_k_args=$(fai-chboot -L '^default$' | \
 # https://wiki.archlinux.org/index.php/Solid_state_drive#Resolving_NCQ_errors
 # currently on needed on d16 samsung 870 qvo, but better to have this
 # and not wait for more conditions where its needed.
+#k_args=(FAI_ACTION=$fai_action libata.force=noncq ifname:bootnet0:08:60:6e:10:f0:fe ifname:bootnet1:08:60:6e:10:f0:98 bond=bond0:bootnet0,bootnet1:mode=balance-rr)
+#k_args=(FAI_ACTION=$fai_action libata.force=noncq ifname:bootnet0:08:60:6e:10:f0:fe biosdevname=0 bootdev=bootnet0)
 k_args=(FAI_ACTION=$fai_action libata.force=noncq)
 if $kgped16; then
   k_args+=(console=tty0 console=ttyS0,115200)
@@ -122,6 +150,14 @@ for arg in $default_k_args; do
   case $arg in
     # default root arg is /srv/fai/nfsroot
     root=*) k_args+=(root=$root_arg) ;;
+    # note: this works to only dhcp on one interface: ip=eth0:dhcp
+    ip=*)
+      if $bond; then
+        k_args+=("bond=bond0:eth0,eth1:mode=balance-rr ip=bond0:dhcp")
+      else
+        k_args+=($arg)
+      fi
+      ;;
     *) k_args+=($arg) ;;
   esac
 done